<?php
/**
 * Copyright 2018 © Pinpoint Designs. All rights reserved.
 */
namespace Pinpoint\PdfUpload\Controller\Adminhtml\Wysiwyg\Images;

use Magento\Backend\App\Action;

/**
 * Class Thumbnail
 * @package Pinpoint\PdfUpload\Controller\Adminhtml\Wysiwyg\Images
 */
class Thumbnail extends \Magento\Cms\Controller\Adminhtml\Wysiwyg\Images\Thumbnail
{
    /**
     * @var string
     */
    const PDF_ICON = 'Pinpoint_PdfUpload::images/pdf-icon.png';

    /**
     * @var \Magento\Framework\View\Asset\Repository
     */
    protected $assetRepository;

    /**
     * @var \Magento\Cms\Helper\Wysiwyg\Images
     */
    protected $images;

    /**
     * Thumbnail constructor.
     * @param Action\Context $context
     * @param \Magento\Framework\Registry $coreRegistry
     * @param \Magento\Framework\Controller\Result\RawFactory $resultRawFactory
     * @param \Magento\Framework\View\Asset\Repository $assetRepository
     * @param \Magento\Cms\Helper\Wysiwyg\Images $images
     */
    public function __construct(
        Action\Context $context,
        \Magento\Framework\Registry $coreRegistry,
        \Magento\Framework\Controller\Result\RawFactory $resultRawFactory,
        \Magento\Framework\View\Asset\Repository $assetRepository,
        \Magento\Cms\Helper\Wysiwyg\Images $images
    ) {
        $this->assetRepository = $assetRepository;
        $this->images = $images;
        parent::__construct($context, $coreRegistry, $resultRawFactory);
    }

    /**
     * @return \Magento\Framework\Controller\Result\Raw
     */
    public function execute()
    {
        $file = $this->getRequest()->getParam('file');
        $file = $this->images->idDecode($file);

        if (explode('.', $file)[1] == 'pdf') {

            $params = [
                'area' => 'adminhtml'
            ];

            $asset = $this->assetRepository->createAsset(self::PDF_ICON, $params);
            $resultRaw = $this->resultRawFactory->create();
            $resultRaw->setHeader('Content-Type', 'image/' . $asset->getContentType());
            $resultRaw->setContents($asset->getContent());
            return $resultRaw;

        }

        return parent::execute();
    }
}
